## ros-rolling-backward-ros 1.0.2

=== CMakeLists.txt ===
#
# CMakeLists.txt
# Copyright 2013 Google Inc. All Rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

cmake_minimum_required(VERSION 3.5)
project(backward_ros)


find_package(ament_cmake)
include(cmake/BackwardConfig.cmake)

set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_CXX_STANDARD 11)

###############################################################################
# COMPILER FLAGS
###############################################################################

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_COMPILER_IS_GNUCXX)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic-errors")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")
endif()

###############################################################################
# BACKWARD OBJECT
###############################################################################
include_directories(include)

add_library(backward_object OBJECT src/backward.cpp)
target_compile_definitions(backward_object PRIVATE ${BACKWARD_DEFINITIONS})
target_include_directories(backward_object PRIVATE ${BACKWARD_INCLUDE_DIRS})
set(BACKWARD_ENABLE $<TARGET_OBJECTS:backward_object> CACHE STRING
	"Link with this object to setup backward automatically")


###############################################################################
# BACKWARD LIBRARY (Includes backward.cpp)
###############################################################################
option(BACKWARD_SHARED "Build dynamic backward-cpp shared lib" OFF)

if(BACKWARD_SHARED)
    set(libtype SHARED)
endif()
add_library(backward SHARED ${libtype} src/backward.cpp)
add_backward(backward)
target_compile_definitions(backward PUBLIC ${BACKWARD_DEFINITIONS})
target_include_directories(backward PUBLIC ${BACKWARD_INCLUDE_DIRS})

###############################################################################
# TESTS
###############################################################################

if(BACKWARD_TESTS)
	enable_testing()

	add_library(test_main SHARED test/_test_main.cpp)

	macro(backward_add_test src)
		get_filename_component(name ${src} NAME_WE)
		set(test_name "test_${name}")

		add_executable(${test_name} ${src} ${ARGN})

		target_link_libraries(${test_name} PRIVATE Backward::Backward test_main)

		add_test(NAME ${name} COMMAND ${test_name})
	endmacro()

	# Tests without backward.cpp
	set(TESTS
		test
		stacktrace
		rectrace
		select_signals
		)

	foreach(test ${TESTS})
		backward_add_test(test/${test}.cpp)
	endforeach()

	# Tests with backward.cpp
	set(TESTS
		suicide
		)

	foreach(test ${TESTS})
		backward_add_test(test/${test}.cpp ${BACKWARD_ENABLE})
	endforeach()
endif()

install(TARGETS backward
  DESTINATION lib)
ament_export_libraries(backward)

install(DIRECTORY include/
  DESTINATION include)
ament_export_include_directories(include)

install(DIRECTORY cmake
	DESTINATION share/${PROJECT_NAME}
)
ament_package(
	CONFIG_EXTRAS_POST "cmake/BackwardConfig.cmake" "cmake/BackwardConfigAment.cmake"
)

## ros-rolling-backward-ros 1.0.1

=== debian/changelog ===
ros-rolling-backward-ros (1.0.1-1focal) focal; urgency=high

  * Add missing ament_cmake dependency
  * Contributors: Victor Lopez

 -- Victor López <victor.lopez@pal-robotics.com>  Tue, 13 Jul 2021 22:00:00 -0000

ros-rolling-backward-ros (1.0.0-1focal) focal; urgency=high

  * Update backward.hpp from https://github.com/bombela/backward-cpp
  * Update README
  * Update package.xml
  * Adapt package to ROS2
  * Contributors: Victor Lopez

 -- Victor López <victor.lopez@pal-robotics.com>  Mon, 12 Jul 2021 22:00:00 -0000

ros-rolling-backward-ros (0.1.7-1focal) focal; urgency=high

  * Merge pull request #3 from veimox/bugfix/fix-tests-headers
    modified heders to be included with current cmake configuration
  * modified heders to be included with current cmake configuration
  * Contributors: Jorge Rodriguez, Victor Lopez

 -- Victor López <victor.lopez@pal-robotics.com>  Thu, 10 Jan 2019 23:00:00 -0000

ros-rolling-backward-ros (0.1.6-1focal) focal; urgency=high

  * Replace #warning with #pragma message
  * Update backward to the latest version
  * Fx wrong LIBRARIES variable concatenation
  * Contributors: Victor Lopez

 -- Victor López <victor.lopez@pal-robotics.com>  Tue, 01 May 2018 22:00:00 -0000

ros-rolling-backward-ros (0.1.5-1focal) focal; urgency=high

  * Fixed version for finding libraries for catkin_make
  * Resolve relative paths generated by catkin_make
  * Merge branch 'fix_typos' into 'master'
    Fix typos in README.md
    See merge request qa/backward_ros!1
  * Fix typos in README.md
  * Change Readme.md so we put backward_ros specific information.
  * Force backward lib to link with backward targets
  * Contributors: Jordan Palacios, Victor, Victor Lopez

 -- Victor López <victor.lopez@pal-robotics.com>  Thu, 26 Apr 2018 22:00:00 -0000

ros-rolling-backward-ros (0.1.4-1focal) focal; urgency=high

  * Rosify backward cpp, add automatic sighandle and rosconsole print
  * Update doc about color mode & std::ostream.
  * Fix typo in build link
  * Merge pull request #62 from bryant1410/master
    Fix broken headings in Markdown files
  * Add color mode.
    This is a breaking change.
    The printer now offers a color_mode setting: automatic, always, never.
    When given a FILE* stream on linux, the automatic mode will retrieve
    file descriptor behind it and call isatty().
  * Merge branch 'print-to-streams' of https://github.com/ogdf/backward-cpp into ogdf-print-to-streams
  * Fix broken Markdown headings
  * Merge pull request #60 from ogdf/g++7-warnings
    Fix g++ 7.0.1 warnings
  * enable tests that somebody thought it was a good idea to permanently disable.
  * Only catch signals with a default action of "Core"
    Close #59
  * Fix g++- 7.0.1 -Wshadow warnings in test lib
  * Fix -Wshadow warnings from g++ 7.0.1
  * Fix -Wimplicit-fallthrough warning from g++ 7.0.1
    The fallthrough (missing break after a case in a switch) is
    not necessary. We can just move the whole default code move
    down after the switch.
  * Merge pull request #58 from krf/fix-warning
    Fix -Wmissing-noreturn warning from Clang
  * Fix -Wmissing-noreturn warning from Clang
  * Merge pull request #56 from akreuzkamp/master
    Operator names are not supported by MSVC out of the box. Using them breaks code that needs to build with MSVC and/or (thus) uses "-fno-operator-names". As a header-only library should pursue maximal
    portability, this PR replaces the single usage of operator names with the more portable operator syntax.
  * Use && instead of and.
    Operator names are not supported by MSVC out of the box. Using them
    breaks code that needs to build with MSVC and/or (thus) uses
    "-fno-operator-names". As a header-only library should pursue maximal
    portability, this commit replaces the single usage of operator names
    with the more portable operator syntax.
  * Merge pull request #57 from bombela/issue-55
    Fix conanfile recipe
  * [#55] Conan options are represented as attributes instead of map entries
  * Revert "[#55] omit cmake options in conanfile build step"
    This reverts commit 06fb80378505d5792c8ce8dcadacdabb9ae45ce7.
  * [#55] omit cmake options in conanfile build step
  * conan recipe url field points to official repository
  * Conan badge pointing to 1.3.0 release
  * conan recipe pointing to 1.3.0 release
  * Update travis ci badge to point to official builds
  * conan.io package
  * Merge pull request #49 from ruipires/master
    adds support for ppc architecture
  * Run tests on Travis CI
  * adds support for ppc architecture
  * Merge pull request #45 from edisongustavo/master
    Add support to find_package(Backward)
  * Add detailed instructions on how to use cmake to integrate Backward
  * Prevent that the cmake variable BACKWARD_INCLUDE_DIRS be infinitely appended on successive cmake runs
  * Don't use find_package() in CMakeLists.txt since it does not make sense
  * Merge pull request #44 from ogdf/make-skip-public
    Make StackTraceImpl*::skip_n_firsts() setter public
  * Merge pull request #43 from ogdf/make-context-sizes-configurable
    Printer: Make context sizes configurable
  * Add install()
  * Add support to find_package(Backward)
  * Make StackTraceImpl*::skip_n_firsts() setter public
    When the stack trace is used directly (and not by a signal),
    one may want to hide some of the first stack items because
    they will always be the same calls.
  * Printer: Make context sizes configurable
  * Let Colorizer reset on initialization
  * Make Printer::print methods available for streams
  * Merge pull request #40 from Jiboo/master
    Don't append definitions if already cached
  * Don't append definitions if already cached
  * Merge pull request #39 from merlinthered/master
    Some CMake-related fixes
  * Export BACKWARD_[...] CMake variables as cache variables


=== debian/control ===
Source: ros-rolling-backward-ros
Section: misc
Priority: optional
Maintainer: Victor López <victor.lopez@pal-robotics.com>
Build-Depends: debhelper (>= 9.0.0), libdw-dev, ros-rolling-ament-cmake, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-backward-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdw-dev, ros-rolling-ros-workspace
Description: The backward_ros package is a ros wrapper of backward-cpp from https://github.com/bombela/backward-cpp

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-backward-ros//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-backward-ros 1.0.2

=== debian/changelog ===
ros-rolling-backward-ros (1.0.2-4jammy) jammy; urgency=high

  * Merge pull request #11 from vatanaksoytezer/vatan/fix_fphsa
    Fix name mismatch warnings
  * Fix name mismatch warnings
  * Contributors: Jordan Palacios, Vatan Aksoy Tezer

 -- Victor López <victor.lopez@pal-robotics.com>  Thu, 31 Mar 2022 07:00:00 -0000

ros-rolling-backward-ros (1.0.1-4jammy) jammy; urgency=high

  * Add missing ament_cmake dependency
  * Contributors: Victor Lopez

 -- Victor López <victor.lopez@pal-robotics.com>  Wed, 14 Jul 2021 07:00:00 -0000

ros-rolling-backward-ros (1.0.0-4jammy) jammy; urgency=high

  * Update backward.hpp from https://github.com/bombela/backward-cpp
  * Update README
  * Update package.xml
  * Adapt package to ROS2
  * Contributors: Victor Lopez

 -- Victor López <victor.lopez@pal-robotics.com>  Tue, 13 Jul 2021 07:00:00 -0000

ros-rolling-backward-ros (0.1.7-4jammy) jammy; urgency=high

  * Merge pull request #3 from veimox/bugfix/fix-tests-headers
    modified heders to be included with current cmake configuration
  * modified heders to be included with current cmake configuration
  * Contributors: Jorge Rodriguez, Victor Lopez

 -- Victor López <victor.lopez@pal-robotics.com>  Fri, 11 Jan 2019 08:00:00 -0000

ros-rolling-backward-ros (0.1.6-4jammy) jammy; urgency=high

  * Replace #warning with #pragma message
  * Update backward to the latest version
  * Fx wrong LIBRARIES variable concatenation
  * Contributors: Victor Lopez

 -- Victor López <victor.lopez@pal-robotics.com>  Wed, 02 May 2018 07:00:00 -0000

ros-rolling-backward-ros (0.1.5-4jammy) jammy; urgency=high

  * Fixed version for finding libraries for catkin_make
  * Resolve relative paths generated by catkin_make
  * Merge branch 'fix_typos' into 'master'
    Fix typos in README.md
    See merge request qa/backward_ros!1
  * Fix typos in README.md
  * Change Readme.md so we put backward_ros specific information.
  * Force backward lib to link with backward targets
  * Contributors: Jordan Palacios, Victor, Victor Lopez

 -- Victor López <victor.lopez@pal-robotics.com>  Fri, 27 Apr 2018 07:00:00 -0000

ros-rolling-backward-ros (0.1.4-4jammy) jammy; urgency=high

  * Rosify backward cpp, add automatic sighandle and rosconsole print
  * Update doc about color mode & std::ostream.
  * Fix typo in build link
  * Merge pull request #62 from bryant1410/master
    Fix broken headings in Markdown files
  * Add color mode.
    This is a breaking change.
    The printer now offers a color_mode setting: automatic, always, never.
    When given a FILE* stream on linux, the automatic mode will retrieve
    file descriptor behind it and call isatty().
  * Merge branch 'print-to-streams' of https://github.com/ogdf/backward-cpp into ogdf-print-to-streams
  * Fix broken Markdown headings
  * Merge pull request #60 from ogdf/g++7-warnings
    Fix g++ 7.0.1 warnings
  * enable tests that somebody thought it was a good idea to permanently disable.
  * Only catch signals with a default action of "Core"
    Close #59
  * Fix g++- 7.0.1 -Wshadow warnings in test lib
  * Fix -Wshadow warnings from g++ 7.0.1
  * Fix -Wimplicit-fallthrough warning from g++ 7.0.1
    The fallthrough (missing break after a case in a switch) is
    not necessary. We can just move the whole default code move
    down after the switch.
  * Merge pull request #58 from krf/fix-warning
    Fix -Wmissing-noreturn warning from Clang
  * Fix -Wmissing-noreturn warning from Clang
  * Merge pull request #56 from akreuzkamp/master
    Operator names are not supported by MSVC out of the box. Using them breaks code that needs to build with MSVC and/or (thus) uses "-fno-operator-names". As a header-only library should pursue maximal
    portability, this PR replaces the single usage of operator names with the more portable operator syntax.
  * Use && instead of and.
    Operator names are not supported by MSVC out of the box. Using them
    breaks code that needs to build with MSVC and/or (thus) uses
    "-fno-operator-names". As a header-only library should pursue maximal
    portability, this commit replaces the single usage of operator names
    with the more portable operator syntax.
  * Merge pull request #57 from bombela/issue-55
    Fix conanfile recipe
  * [#55] Conan options are represented as attributes instead of map entries
  * Revert "[#55] omit cmake options in conanfile build step"
    This reverts commit 06fb80378505d5792c8ce8dcadacdabb9ae45ce7.
  * [#55] omit cmake options in conanfile build step
  * conan recipe url field points to official repository
  * Conan badge pointing to 1.3.0 release
  * conan recipe pointing to 1.3.0 release
  * Update travis ci badge to point to official builds
  * conan.io package
  * Merge pull request #49 from ruipires/master
    adds support for ppc architecture
  * Run tests on Travis CI
  * adds support for ppc architecture
  * Merge pull request #45 from edisongustavo/master
    Add support to find_package(Backward)
  * Add detailed instructions on how to use cmake to integrate Backward
  * Prevent that the cmake variable BACKWARD_INCLUDE_DIRS be infinitely appended on successive cmake runs
  * Don't use find_package() in CMakeLists.txt since it does not make sense
  * Merge pull request #44 from ogdf/make-skip-public
    Make StackTraceImpl*::skip_n_firsts() setter public
  * Merge pull request #43 from ogdf/make-context-sizes-configurable
    Printer: Make context sizes configurable
  * Add install()
  * Add support to find_package(Backward)
  * Make StackTraceImpl*::skip_n_firsts() setter public
    When the stack trace is used directly (and not by a signal),
    one may want to hide some of the first stack items because
    they will always be the same calls.
  * Printer: Make context sizes configurable
  * Let Colorizer reset on initialization
  * Make Printer::print methods available for streams
  * Merge pull request #40 from Jiboo/master
    Don't append definitions if already cached


=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
